#! /bin/sh
#***********************************************************************#
#                                                                       #
#                               NOTICE                                  #
#                                                                       #
#                  COPYRIGHT 2012 QLOGIC CORPORATION                    #
#                        ALL RIGHTS RESERVED                            #
#                                                                       #
#  This computer program is CONFIDENTIAL  and contains TRADE SECRETS of #
#  QLOGIC CORPORATION.  The  receipt or possession of this program does #
#  not convey any rights to reproduce or disclose  its contents,  or to #
#  manufacture, use, or sell anything that it may describe, in whole or #
#  in part, without the specific written consent of QLOGIC CORPORATION. #
#  Any reproduction of this program without the express written consent #
#  of QLOGIC CORPORATION  is a violation of the copyright laws and  may #
#  subject you to civil liability and criminal prosecution.             #
#                                                                       #
#***********************************************************************#

# If the GPL Nic driver was blacklisted then remove that blacklisting.
exec_script="/usr/bin/nx_snmp.pl"
mid_obj_id=".1.3.6.1.2.1.10.7.11.1"
pass_entry="pass ${mid_obj_id} ${exec_script}"
snmpd_conf="/etc/snmp/snmpd.conf"
netxen_driver=`modinfo netxen_nic  > /dev/null 2>&1 && echo "yes" || echo "no"`
bl_files="/etc/modprobe.d/blacklist /etc/hotplug/blacklist  /etc/modprobe.d/blacklist.conf /etc/modprobe.conf.local /etc/modprobe.conf /etc/modules.conf"
for f in $bl_files
do
        if [ -f $f ]; then
        break
        fi
done

blacklist_file=$f
if [ "$f" != "/etc/hotplug/blacklist" ]; then
        blacklist_entry="blacklist netxen_nic"
	blacklist_nx_xport="blacklist nx_xport"
else
        blacklist_entry="netxen_nic"
	blacklist_nx_xport="nx_xport"
fi

modprob_conf="/etc/modprobe.conf"

if [ ${netxen_driver} == "yes" ]; then
    grep -v "${blacklist_entry}" ${blacklist_file} > ${blacklist_file}.tmp
    mv ${blacklist_file}.tmp ${blacklist_file}
    grep -v "${blacklist_nx_xport}" ${blacklist_file} > ${blacklist_file}.tmp
    mv ${blacklist_file}.tmp ${blacklist_file}
fi
depmod
if [ -f ${snmpd_conf} ]; then
    grep -v "${pass_entry}" ${snmpd_conf} > ${snmpd_conf}.tmp
    mv ${snmpd_conf}.tmp ${snmpd_conf}
fi
if [ -f ${modprob_conf} ]; then
    cp ${modprob_conf} ${modprob_conf}.saved
    grep -v -E "install netxen_nic /sbin/modprobe nx_nic" ${modprob_conf}.saved > ${modprob_conf}
    cp ${modprob_conf} ${modprob_conf}.saved
    grep -v -E "install nx_xport /bin/true" ${modprob_conf}.saved > ${modprob_conf}
    rm ${modprob_conf}.saved
fi
